\documentclass[a4paper, trou]{./tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Computer Science}
\ddmodulenumber{Tutorial minidem}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien



\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  




\newdemexo{05}{A Viscous Billiard Game}

\noindent The goal of this tutorial is to show you how to introduce
viscous damping into a simulation.

\vspace{0.5cm}

\begin{task}
  Download the module \dldem{minidem.py} and the script
  \dltutodem{05}{tuto-05\_exercice.py}. Run the script
  \dltutodem{05}{tuto-05\_exercice.py}.
\end{task}

\begin{info}
At this stage, you should obtain a simulation similar to the video \dltutodem{05}{tuto-05\_exercice.mp4}.
\end{info}

\begin{task}
  Change the initial conditions according to the parameters of the scheme
  below to achieve a \textit{billiard game}.
\end{task}


\begin{center}
  \svgb{0.8\linewidth}{./img/tuto-minidem_05.pdf_tex}
\end{center}

\begin{task}
  Change the number of iterations to \texttt{10000}.
\end{task}

\begin{info}
  To make the simulation more realistic, you will introduce viscous
  damping which will slow down the particles. This damping is introduced via viscous forces opposing the velocity of the particles according to the formula:
  \begin{equation}
    \vec{f}_{i} = -C . \vec{v}_{i}\nonumber
  \end{equation}
  where:
  \begin{itemize}
  \item $\vec{f}_{i}$ is the viscous force applied to particle $i$
  \item $C$ is the viscous damping coefficient 
  \item $\vec{v}_{i}$ is the velocity of particle $i$
  \end{itemize}
\end{info}


\begin{task}
  Create a new function \texttt{add\_viscous\_force()} that
  increments the force applied to each particle according to the formula
  above. Use a viscous damping coefficient $C=10$.
\end{task}

\begin{task}
  Call this function in the \textit{time loop} as the second step,
  that is, right after \texttt{reset\_force()}.
\end{task}


\begin{info}
  At this stage, you should obtain a simulation similar to the video \dltutodem{05}{tuto-05\_correction.mp4}.
\end{info}

\end{document}
